/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreValuelistPersonlistRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreValuelistPersonlist extends TableImpl<VCoreValuelistPersonlistRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of
     * <code>common_dd.v_core_valuelist_personlist</code>
     */
    public static final VCoreValuelistPersonlist V_CORE_VALUELIST_PERSONLIST = new VCoreValuelistPersonlist();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreValuelistPersonlistRecord> getRecordType() {
        return VCoreValuelistPersonlistRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_valuelist_personlist.valuelist</code>.
     */
    public final TableField<VCoreValuelistPersonlistRecord, Integer> VALUELIST = createField(DSL.name("valuelist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_personlist.user</code>.
     */
    public final TableField<VCoreValuelistPersonlistRecord, String> USER = createField(DSL.name("user"), SQLDataType.CLOB, this, "");

    private VCoreValuelistPersonlist(Name alias, Table<VCoreValuelistPersonlistRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreValuelistPersonlist(Name alias, Table<VCoreValuelistPersonlistRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_valuelist_personlist" as  SELECT sub.valuelist,
          string_agg((((((((sub.x).value)::text)::integer || ' - '::text) || t_core_person.forename) || ' '::text) || t_core_person.surname), ', '::text ORDER BY (sub.x).key) AS "user"
         FROM (( SELECT t_core_valuelist.valuelist,
                  jsonb_each(t_core_valuelist."values") AS x
                 FROM common_dd.t_core_valuelist
                WHERE (t_core_valuelist.fk_valuetype = 3)) sub
           LEFT JOIN common_dd.t_core_person ON (((((sub.x).value)::text)::integer = t_core_person.usnr)))
        GROUP BY sub.valuelist;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_valuelist_personlist</code>
     * table reference
     */
    public VCoreValuelistPersonlist(String alias) {
        this(DSL.name(alias), V_CORE_VALUELIST_PERSONLIST);
    }

    /**
     * Create an aliased <code>common_dd.v_core_valuelist_personlist</code>
     * table reference
     */
    public VCoreValuelistPersonlist(Name alias) {
        this(alias, V_CORE_VALUELIST_PERSONLIST);
    }

    /**
     * Create a <code>common_dd.v_core_valuelist_personlist</code> table
     * reference
     */
    public VCoreValuelistPersonlist() {
        this(DSL.name("v_core_valuelist_personlist"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreValuelistPersonlist as(String alias) {
        return new VCoreValuelistPersonlist(DSL.name(alias), this);
    }

    @Override
    public VCoreValuelistPersonlist as(Name alias) {
        return new VCoreValuelistPersonlist(alias, this);
    }

    @Override
    public VCoreValuelistPersonlist as(Table<?> alias) {
        return new VCoreValuelistPersonlist(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistPersonlist rename(String name) {
        return new VCoreValuelistPersonlist(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistPersonlist rename(Name name) {
        return new VCoreValuelistPersonlist(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistPersonlist rename(Table<?> name) {
        return new VCoreValuelistPersonlist(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistPersonlist where(Condition condition) {
        return new VCoreValuelistPersonlist(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistPersonlist where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistPersonlist where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistPersonlist where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistPersonlist where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistPersonlist where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistPersonlist where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistPersonlist where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistPersonlist whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistPersonlist whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
